function eje_aux = lanza_axis(dat,pto_origen,Aref,direc,ptos,Nv,tau,muelle,dist_fuera)

if exist('ptos'),dat1=ptos;else, dat1=dat;end
[D N] = size(dat1);
AA = Aref;
nn=0;
for sentido = [1 -1]

    pto = pto_origen;
    Aref = AA;
    orig = 1;
    parar = 0;
    ref = 0;
    while parar == 0
        % PCA

        % Bola redonda

        [R,ind] = sort(sqrt(sum((dat1-repmat(pto,1,N)).^2)));

        % Cogemos una bola mayor de radio RR = sqrt(2)*Maxima Dist para el numero
        % de vecinos dados
        RR = sqrt(2)*R(Nv);
        pos = find(R<=RR);
        dat3 = dat1(:,ind(1:max(pos)));
        [Dim Nvv] = size(dat3);

        % Nos centramos en el punto
        dat3c = dat3-repmat(pto,1,Nvv);

        % PCA sobre dat3c (bola)
        C3 = cov2(dat3c');
        [V3,D3] = eig(C3);

        V3 = V3 * inv(sqrtm(V3'*V3));
        V3 = V3 / (abs(det(V3))^(1/size(V3,1)));

        V3 = alinea_bases(V3,Aref,1);

        V_der = V3;
        V_izq = -V_der;
        V_ref = V_der;

        if muelle==0

        else
            dat3m = V_der'*dat3c;
            
            Vc = mean(dat3m(:,find(dat3m(direc,:)>0))')';
            Vc = Vc/norm(Vc);
            if isnan(sum(Vc)), Vc = zeros(size(V_izq,1),1);end
            
            V_der(:,direc) = V_der(:,direc) + muelle*Vc;
          
            Vc = mean(dat3m(:,find(dat3m(direc,:)<0))')';
            Vc = Vc/norm(Vc);
            if isnan(sum(Vc)), Vc = zeros(size(V_izq,1),1);end
            
            V_izq(:,direc) = V_izq(:,direc) + muelle*Vc;

            V_der = V_der/norm(V_der);
            V_izq = V_izq/norm(V_izq);
        end
        
        V_der = V_der*tau;
        V_izq = V_izq*tau;

        % SAVE
        nn = nn+1;
        if orig == 1
            eje_aux(nn).pto = pto;
            eje_aux(nn).V_der = V_der;
            eje_aux(nn).V_izq = V_izq;
            eje_aux(nn).ref = 0;
            orig = 0;
        else
            ref = ref + 1;
            eje_aux(nn).pto = pto;
            eje_aux(nn).V_der = V_der;
            eje_aux(nn).V_izq = V_izq;
            eje_aux(nn).ref = ref*sentido;
        end

        if sentido == -1
            pto = pto + V_izq(:,direc);
            cond1 = isinf(sqrt(sum(V_izq(:,direc).*V_izq(:,direc))));
            cond2 = isinf(sum(pto));
            cond3 = sqrt(sum(V_izq(:,direc).^2))>1.00000000001*dist_pto_a_ejes(pto,eje_aux);
            cond4 = dist_point_a_data(dat,pto)>dist_fuera;
            %             [ref sentido cond1 cond2 cond3 cond4]
            %             pause
            if(cond1|cond2|cond3|cond4)
                parar=1;
                ref = ref + 1;
                nn = nn+1;
                eje_aux(nn).pto = pto;
                eje_aux(nn).V_der = V_der;
                eje_aux(nn).V_izq = V_izq;
                eje_aux(nn).ref = ref*sentido;
            else
                Aref = V_ref;
            end

        elseif sentido == 1
            pto = pto + V_der(:,direc);
            cond1 = isinf(sqrt(sum(V_der(:,direc).*V_der(:,direc))));
            cond2 = isinf(sum(pto));
            cond3 = sqrt(sum(V_der(:,direc).^2))>1.00000000001*dist_pto_a_ejes(pto,eje_aux);
            cond4 = dist_point_a_data(dat,pto)>dist_fuera;
            %             [ref sentido cond1 cond2 cond3 cond4]
            %             pause
            if(cond1|cond2|cond3|cond4)
                %             if(isinf(sqrt(sum(V_der(:,direc).*V_der(:,direc))))|isinf(sum(pto))|...
                %                     sqrt(sum(V_der(:,direc).^2))>1.00000000001*dist_pto_a_ejes(pto,eje_aux)|dist_pto_a_datos(pto)>dist_fuera)
                %
                parar=1;
                ref = ref + 1;
                nn = nn+1;
                eje_aux(nn).pto = pto;
                eje_aux(nn).V_der = V_der;
                eje_aux(nn).V_izq = V_izq;
                eje_aux(nn).ref = ref*sentido;
            else
                Aref = V_ref;
            end
        end
        % hold on,plot(pto(1),pto(2),'ro')
        % hold on,plot3(pto(1),pto(2),pto(3),'ro','markersize',3)
    end

end
