function [EJ] = modifica_axes_2(dat,R,init_param)

% USE:
% [EJ] = modifica_axes(dat,R,init_param)
%


dist_fuera = init_param.dist_out;
pto_origen = init_param.origin;
Aref = init_param.Aref;
Nbins = init_param.Nbins;
Nv = init_param.k;
muelle = init_param.q;

tau = init_param.tau;
eje_principal = init_param.eucl_PC;
CRIT = init_param.CRIT;
pto_proximo_principal = init_param.points_on_eucl_PC;
resp_principal = init_param.first_eucl_responses;


[DIM N] = size(dat);

direc = 1;
eje = eje_principal;

%%%%%%%%%%%%%%%%%%%%%%%%
n1 = find(cat(1,eje(:).ref)==fix(R(direc)));
n2 = find(cat(1,eje(:).ref)==sign(R(direc))+ fix(R(direc)));

if isempty(n1),
    n1 = find(cat(1,eje(:).ref) == max(cat(1,eje(:).ref)));
end
pto1 = eje(n1(1)).pto;
if isempty(n2),
    pto2 = pto1;
else pto2 = eje(n2(1)).pto;
end

vect21 = pto2-pto1;
dec = abs(R(direc)-fix(R(direc)));
[pto_proximo] = pto1 + dec*vect21;
pto_origen = pto_proximo;
Aref = eje(n1(1)).V_der;

EG(1).eje = eje_principal;

EJ(1).pto_proyeccion = pto_proximo;
ptos = dat;
Nvn = Nv;
for direc = 2:DIM

    clear resp ptos_proximo
    if direc == 2
        pto_proximo = pto_proximo_principal;
        resp = resp_principal;
    else
        for n=1:size(ptos,2)
            [pto_proximo(:,n),resp(:,n)] = punto_en_eje_NLPCA(ptos(:,n),eje);
        end
    end

    aux_res = abs(resp-R(direc-1));
    [sss iii] = sort(aux_res);
    Nvn = round(Nvn/2);
    ptos = dat(:,iii(1:5*Nvn));
    
    eje = lanza_axis(dat,pto_origen,Aref,direc,ptos,Nvn,tau,muelle,dist_fuera);
    % plotea_eje(eje,'go-',2)
    EG(direc).eje = eje;

    for n=1:size(dat,2)
        d(n) = dist_pto_a_ejes(dat(:,n),eje);
    end

    for nn=1:direc-1, qqq(nn) = length(EG(nn).eje);end
    
    [ss ii] = sort(d);
%     Npoints = round(size(ptos,2)*1.5);
    Npoints = min(round(size(ptos,2)*0.85),length(ii));
    dat_tubo = dat(:,ii(1:Npoints));
    
   % eje = modifica_eje(eje,pto_origen,dat_tubo,Nbins(direc),Aref,0,Nvn);

    EJ(direc).eje = modifica_axis(dat,eje,pto_origen,dat_tubo,Nbins(direc),Aref,0,Nvn,CRIT);

    %%%%%%%%%%%%%%%%%%%%%%%%
    n1 = find(cat(1,eje(:).ref)==fix(R(direc)));
    n2 = find(cat(1,eje(:).ref)==sign(R(direc))+ fix(R(direc)));
    if isempty(n1),
        n1 = find(cat(1,eje(:).ref) == max(cat(1,eje(:).ref)));
    end
    pto1 = eje(n1(1)).pto;
    if isempty(n2),
        pto2 = pto1;
    else pto2 = eje(n2(1)).pto;
    end

    vect21 = pto2-pto1;
    dec = abs(R(direc)-fix(R(direc)));
    
    [pto_proximo] = pto1 + dec*vect21;     
    
    Aref = eje(n1(1)).V_der;
     pto_origen = pto_proximo;
    EJ(direc).pto_proyeccion = pto_proximo;

     %     plotea_eje(eje,'co-')
%   hold on,plot3(pto_proximo(1,:),pto_proximo(2,:),pto_proximo(3,:),'co-','linewidth',3)
%     hold on,plot3(pto_proximo(1,:),pto_proximo(2,:),pto_proximo(3,:),'kx-')
end



