function R=rmse(A,B)

%
% RMSE computes the squared root MSE among two sets of vectors A and B,
% where A and B are matrices of size d*n ("d" dimensions times "n" samples)
%
% RMSE=rmse(A,B);
%

[L1 L2] = size(A);
R=sqrt(sum(sum((double(A)-double(B)).^2))/prod([L1 L2]));