function V3 = pca_en_point(dat,pto_proximo,Nv)

[DIM N] = size(dat);

% Bola redonda
[R2,ind] = sort(sqrt(sum((dat-repmat(pto_proximo,1,N)).^2)));
RR = sqrt(2)*R2(Nv);
pos = find(R2<=RR);
dat3 = dat(:,ind(1:max(pos)));
[Dim Nvv] = size(dat3);

% Nos centramos en el punto
dat3c = dat3-repmat(pto_proximo,1,Nvv);

% PCA sobre dat3c (bola)
C3 = cov2(dat3c');
[V3,D3] = eig(C3);
